﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Phone图块.Resources;
using System.Windows.Media;

namespace Phone图块
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();

            // 用于本地化 ApplicationBar 的示例代码
            //BuildLocalizedApplicationBar();
        }


        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            CreateTitle();
        }


        private void ShowTitle()
        {
            var tilte = ShellTile.ActiveTiles.FirstOrDefault();
            if (tilte != null)
            {
                MessageBox.Show(tilte.NavigationUri.ToString());
            }
        }

        //图标图块
        IconicTileData iconicTileData = new IconicTileData()
        {
            Title = "标题",
            Count = 5,
            WideContent1 = "第一行文本",
            WideContent2 = "第二行文本",
            WideContent3 = "第三行文本",
            SmallIconImage = new Uri("/Assets/Tiles/IconLarge.png", UriKind.Relative),
            IconImage = new Uri("/Assets/Tiles/IconSamall.png", UriKind.Relative),
            //透明度设置为255才会显示自定义颜色背景，否则显示为系统背景
            BackgroundColor = new Color { A = 255, R = 0, G = 148, B = 255 }
        };

        //图标图块模板
        string iconicTileXml = @"<?xml version=""1.0"" encoding=""utf-8""?>
                        <wp:Notification xmlns:wp=""WPNotification"" Version=""2.0"">
                          <wp:Tile Id=""titleid1"" Template=""IconicTile"">
                            <wp:SmallIconImage>/Assets/Tiles/IconLarge.png</wp:SmallIconImage>
                            <wp:IconImage>/Assets/Tiles/IconSamall.png</wp:IconImage>
                            <wp:WideContent1>第一行文本</wp:WideContent1>
                            <wp:WideContent2 Action=""Clear"">第二行文本</wp:WideContent2>
                            <wp:WideContent3>第三行文本</wp:WideContent3>
                            <wp:Count>6</wp:Count>
                            <wp:Title>标题</wp:Title>
                            <wp:BackgroundColor>#FF524742</wp:BackgroundColor>
                          </wp:Tile>
                        </wp:Notification>";

        //可用于清除Count（如果加了Action="Clear",则清除该项的显示）
        string iconicTileXml2 = @"<?xml version=""1.0"" encoding=""utf-8""?>
                        <wp:Notification xmlns:wp=""WPNotification"" Version=""2.0"">
                          <wp:Tile Id=""titleid1"" Template=""IconicTile"">
                            <wp:Count Action=""Clear"">0</wp:Count>
                          </wp:Tile>
                        </wp:Notification>";

        //翻转图块
        FlipTileData flipTileData = new FlipTileData()
        {
            Title = "标题",
            BackTitle = "背面标题",
            BackContent = "背面的文本内容部分",
            WideBackContent = "在宽图块背面的文本内容",
            Count = 5,
            SmallBackgroundImage = new Uri("/Assets/Tiles/Samall.png", UriKind.Relative),
            BackgroundImage = new Uri("/Assets/Tiles/Medium.png", UriKind.Relative),
            //不设置背景图像则显示为系统背景色
            //BackBackgroundImage = new Uri("Assets/Tiles/FlipCycleTileMedium.png", UriKind.Relative),

            WideBackgroundImage = new Uri("/Assets/Tiles/Large.png", UriKind.Relative),
            //WideBackBackgroundImage = new Uri("/Assets/Tiles/IconicTileMediumLarge.png", UriKind.Relative)
        };
        //翻转图块模板
        string flipTileXml = @"<?xml version=""1.0"" encoding=""utf-8""?>
                        <wp:Notification xmlns:wp=""WPNotification"" Version=""2.0"">
                            <wp:Tile Id=""titleid2"" Template=""FlipTile"">
                            <wp:SmallBackgroundImage>/Assets/Tiles/Samall.png</wp:SmallBackgroundImage>
                            <wp:WideBackgroundImage>/Assets/Tiles/Large.png</wp:WideBackgroundImage>
                            <wp:WideBackBackgroundImage>/Assets/Tiles/IconicTileMediumLarge.png</wp:WideBackBackgroundImage>
                            <wp:WideBackContent>在宽图块背面的文本内容</wp:WideBackContent>
                            <wp:BackgroundImage>/Assets/Tiles/Medium.png</wp:BackgroundImage>
                            <wp:Count>6</wp:Count>
                            <wp:Title>标题</wp:Title>
                            <wp:BackBackgroundImage>Assets/Tiles/FlipCycleTileMedium.png</wp:BackBackgroundImage>
                            <wp:BackTitle>背面标题</wp:BackTitle>
                            <wp:BackContent>背面的文本内容部分</wp:BackContent>
                            </wp:Tile>
                        </wp:Notification>";


        //循环图块
        CycleTileData cycleTileData = new CycleTileData()
        {
            Title = "标题",
            Count = 10,
            SmallBackgroundImage = new Uri("/Assets/Tiles/Samall.png", UriKind.Relative),
            CycleImages = new Uri[]
                        {
                            new Uri("/Assets/Tiles/Title1.png", UriKind.Relative), 
                            new Uri("/Assets/Tiles/Title2.png", UriKind.Relative), 
                            new Uri("/Assets/Tiles/Title3.png", UriKind.Relative), 
                        }
        };
        //循环图块模板
        string cycleTileXml = @"<?xml version=""1.0"" encoding=""utf-8""?>
                        <wp:Notification xmlns:wp=""WPNotification"" Version=""2.0"">
                          <wp:Tile Id=""titleid3"" Template=""CycleTile"">
                            <wp:SmallBackgroundImage>/Assets/Tiles/Samall.png</wp:SmallBackgroundImage>
                            <wp:CycleImage1>/Assets/Tiles/Title1.png</wp:CycleImage1>
                            <wp:CycleImage2>/Assets/Tiles/Title2.png</wp:CycleImage2>
                            <wp:CycleImage3>/Assets/Tiles/Title3.png</wp:CycleImage3>
                            <wp:Count>6</wp:Count>
                            <wp:Title>标题</wp:Title>
                          </wp:Tile>
                        </wp:Notification>";


        private void CreateTitle()
        {

            //添加一个次要图块
            ShellTile.Create(new Uri("/Page1.xaml", UriKind.Relative), iconicTileData, true);
            //通过xml模板添加
            ShellTile.Create(new Uri("/Page1.xaml", UriKind.Relative), new IconicTileData(iconicTileXml), true);
        }

        private void ClearCount()
        {
            //清除Count
            ShellTile.ActiveTiles.ElementAt(1).Update(new IconicTileData(iconicTileXml2));
        }

        private void UpdateTitle()
        {
            //更新默认图块的内容，我们定义的翻转模版，这里不能修改模版类型
            ShellTile.ActiveTiles.FirstOrDefault().Update(flipTileData);
        }

    }
}